//***************************************************************
//*  sim.C
//*  An example script to run Spring, Hadronizer and QuickSimulator.
//*  Bases data, bases.root, is prepared by bases.C script in the
//*  same directory.
//*  
//*  24-July-1999 Akiya Miyamoto 
//*$Id: sim.C,v 1.3 1999/07/27 04:33:38 miyamoto Exp $
//***************************************************************

TFile *file;

Int_t sim()
{
  gROOT->Reset();
  file=new TFile("jsf.root","RECREATE");  // Output file

  jsf    = new JSFSteer();
  full   = new JSFLCFULL();
  spring = new FFbarSpring(); 
  hdr=new JSFHadronizer();
  sim=new JSFQuickSim();

  Int_t maxevt=10;      // Number of event is 10.
  jsf->Initialize();

  spring->ReadBases("bases.root");  // ReadBases must be called before BeginRun
  //  spring->Bases()->SetSeed(12345);  // Set seed for Spring

  jsf->BeginRun(30);      // Set run number to 30.
  for(Int_t ev=1;ev<=maxevt;ev++){
    printf(" start event %d ",ev);
    if( !jsf->Process(ev)) break;

    //  Example to print Px of first particle.
    FFbarSpring *spr=(FFbarSpring*)jsf->FindModule("FFbarSpring");
    FFbarSpringBuf *sb=(FFbarSpringBuf*)spr->EventBuf();
    TClonesArray *sc=sb->GetPartons();
    JSFSpringParton *p=(JSFSpringParton*)sc->UncheckedAt(0);
    printf(" np=%g",sb->GetNpartons());
    printf(" Px=%g\n",p->GetPx());

    jsf->FillTree();
    jsf->Clear();
  }

  jsf->Terminate();
  file->Write();
}


